import pandas as pd
import numpy as np
from pathlib import Path
import re
from datetime import datetime
from datetime import date
from surrogateFinal import calcul_surrogate
import string
import matplotlib.pyplot as plt
from calcValues import calcValues
import statistics
import xlsxwriter

#column_names = ["Data base source", "Literature reference", "Waste Category", "Subcategory" , "avallskoder", "Moisture content wt%" , "Ash content (at highest T specified) wt%", "Volatile matter  wt%" ,"Fixed carbon wt%","Ash content (at highest T specified) wt%","Volatile matter  wt%" ,"Fixed carbon wt%", "Volatile matter  wt%" ,"Fixed carbon wt%", "C wt%","H wt%","O wt%","N wt%","S wt%", "C wt%","H wt%","O wt%","N wt%","S wt%", "C wt%","H wt%","O wt%","N wt%","S wt%",'Br mg/kg','Cl mg/kg','F mg/kg','Br mg/kg','Cl mg/kg','F mg/kg','Br mg/kg','Cl mg/kg','F mg/kg','LHV MJ/kg','HHV MJ/kg','LHV MJ/kg','HHV MJ/kg','LHV MJ/kg','HHV MJ/kg','Al mg/kg (dry)','As mg/kg (dry)','B mg/kg (dry)','Ba mg/kg (dry)','Ca mg/kg (dry)','Cd mg/kg (dry)','Co mg/kg (dry)','Cr mg/kg (dry)','Cu mg/kg (dry)','Fe mg/kg (dry)','Hg mg/kg (dry)','K mg/kg (dry)','Mg mg/kg (dry)','Mn mg/kg (dry)','Mo mg/kg (dry)','Na mg/kg (dry)','Ni mg/kg (dry)','P mg/kg (dry)','Pb mg/kg (dry)','Sb mg/kg (dry)','Se mg/kg (dry)','Si mg/kg (dry)','Sn mg/kg (dry)','Sr mg/kg (dry)','Ti mg/kg (dry)','V mg/kg (dry)','Zn mg/kg (dry)','Al2O3 wt% (ash)','CaO wt% (ash)','Cl wt% (ash)','CO2 wt% (ash)','Fe2O3 wt% (ash)','K2O wt% (ash)','MgO wt% (ash)','Na2O wt% (ash)','P2O5 wt% (ash)','SiO2 wt% (ash)','SO3 wt% (ash)','TiO2 wt% (ash)','']
table=pd.read_csv('furnitureWood-Input.csv', header=None, skip_blank_lines=True, encoding='cp1252')
table.dropna(how='all', inplace=True)
table[84] = ''

#Make sure that empty values have a space
for j in range(5,83):
  for i in range(5,len(table)):
    if pd.isna(table.iloc[i,j]):
        table.iloc[i,j] = ' '

#Delete top lines and columns outside table
for i in range(0,5):
    table = table.drop(i)

for column in range(84,len(table.columns)):
        table = table.drop(column, axis=1)

table.index = range(0, len(table))
print(len(table))

for row in range(0,len(table)):
   for col in range(5,len(table.columns)):
       if ('<' in str(table.iloc[row,col])) or ('>' in str(table.iloc[row,col])):
                #added part to remove < and >
           table.iloc[row,col]=table.iloc[row,col].replace('<','')
           table.iloc[row,col]=table.iloc[row,col].replace('>','')
           continue 
       if  str(table.iloc[row,col]) == '-':
           continue
       else :
           if not table.iloc[row,col]=='NaN' or table.iloc[row,col]==' ' or not table.iloc[row,col] == 'nan': #changed nan
               if ('.' in str(table.iloc[row,col]) and ',' in str(table.iloc[row,col])):
                   table.iloc[row,col]=table.iloc[row,col].replace(',','')
                   table.iloc[row,col]=float(table.iloc[row,col])
               else :
                   if (',' in str(table.iloc[row,col])):
                       table.iloc[row,col]=table.iloc[row,col].replace(',','.')
                       table.iloc[row,col]=float(table.iloc[row,col])

#Make all values into floats
for j in range(5,83):
  for i in range(0,len(table)):
    if table.iloc[i,j] != ' ':
        table.iloc[i,j] = float(table.iloc[i,j])

for i in range(len(table)-1,-1,-1):
    calcValues(table, i)

print(len(table))

table.columns = ["Data base source", "Literature reference", "Waste Category", "Subcategory" , "avallskoder", "Moisture content wt%" , "Ash content (at highest T specified) wt%", "Volatile matter  wt%" ,"Fixed carbon wt%","Ash content (at highest T specified) wt%","Volatile matter  wt%" ,"Fixed carbon wt%", "Volatile matter  wt%" ,"Fixed carbon wt%", "C wt%","H wt%","O wt%","N wt%","S wt%", "C wt%","H wt%","O wt%","N wt%","S wt%", "C wt%","H wt%","O wt%","N wt%","S wt%",'Br mg/kg','Cl mg/kg','F mg/kg','Br mg/kg','Cl mg/kg','F mg/kg','Br mg/kg','Cl mg/kg','F mg/kg','LHV MJ/kg','HHV MJ/kg','LHV MJ/kg','HHV MJ/kg','LHV MJ/kg','HHV MJ/kg','Al mg/kg (dry)','As mg/kg (dry)','B mg/kg (dry)','Ba mg/kg (dry)','Ca mg/kg (dry)','Cd mg/kg (dry)','Co mg/kg (dry)','Cr mg/kg (dry)','Cu mg/kg (dry)','Fe mg/kg (dry)','Hg mg/kg (dry)','K mg/kg (dry)','Mg mg/kg (dry)','Mn mg/kg (dry)','Mo mg/kg (dry)','Na mg/kg (dry)','Ni mg/kg (dry)','P mg/kg (dry)','Pb mg/kg (dry)','Sb mg/kg (dry)','Se mg/kg (dry)','Si mg/kg (dry)','Sn mg/kg (dry)','Sr mg/kg (dry)','Ti mg/kg (dry)','V mg/kg (dry)','Zn mg/kg (dry)','Al2O3 wt% (ash)','CaO wt% (ash)','Cl wt% (ash)','CO2 wt% (ash)','Fe2O3 wt% (ash)','K2O wt% (ash)','MgO wt% (ash)','Na2O wt% (ash)','P2O5 wt% (ash)','SiO2 wt% (ash)','SO3 wt% (ash)','TiO2 wt% (ash)', '']


column_names = ["C wt%","H wt%","O wt%","N wt%","Cl wt%","S wt%", "Ash wt%","Moisture wt%", "C wt%","H wt%","O wt%","N wt%","Cl wt%",'S wt%','CELL wt%','HCE wt%','LIGC wt%','LIGH wt%','LIGO wt%','PROTC wt%','PROTH wt%','PROTO wt%','SUGAR wt%','LIPID wt%','G(NH3NO) wt%','CO2I wt%','G(H2SSO20CS) wt%','PE wt%','PS wt%','PVC wt%','PA wt%','PP wt%', 'PET wt%', 'NR wt%', 'ASPH wt%', 'H2O(S) wt%','ASH wt%','Biomass_frac','Inorganics_frac','Plastics_frac', 'Hydrocarbons_frac', 'HHV_Surrogate (dry, ash free) MJ/kg','HHV_Surrogate  MJ/kg','']
table2 = pd.DataFrame(columns = column_names,index=np.arange(len(table)))

for row in range(len(table)):
   calcul_surrogate(table,row,table2)    
#Added script to showcase values as graphs

# table2.to_csv('1141-Processed.csv',index=False)

file_name = 'Test-Done.xlsx'
sheet_name = 'Summary'

result = pd.concat([table, table2], axis=1)
writer = pd.ExcelWriter(file_name,engine='xlsxwriter')
result.to_excel(writer, sheet_name=sheet_name,startrow=4, index=False)

workbook  = writer.book
worksheet = writer.sheets[sheet_name]
worksheet.write(0, 0, 'INPUT ->>', workbook.add_format({'bold': True, 'size': 11}))
worksheet.write(0, 5,'Main biomass properties',workbook.add_format({'bold': True, 'size': 11}))
worksheet.write(0, 71,'Ash properties',workbook.add_format({'bold': True, 'size': 11}))
worksheet.write(0, 82,'<-- INPUT',workbook.add_format({'bold': True, 'size': 11}))
worksheet.write(0, 84,'OUTPUT ->>',workbook.add_format({'bold': True, 'size': 11,'color': 'red' }))


'''
add remark at the end of table with last update
'''

worksheet.write(len(result)+6, 0, 'Remark:', workbook.add_format({'bold': True}))
worksheet.write(len(result)+7, 0, 'The last update day is ' + date.today().strftime("%d/%m/%Y") + '.')

# create a format to use in the merged range

merge_format_1 = workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#C00000',
       'color': '#ffffff'})
       
merge_format_2 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#A5A5A5',
       'color': '#ffffff'})

merge_format_3 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#FFC000',
       'color': '#ffffff'})
       
merge_format_4 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#2E75B6',
       'color': '#ffffff'})

merge_format_5 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#92D050',
       'color': '#ffffff'})
       
merge_format_6 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#ED7D31',
       'color': '#ffffff'})

merge_format_7 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#F2F2F2',
       'color': '#000000'})   
   
merge_format_8 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#D9D9D9',
       'color': '#000000'})   

merge_format_9 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#BFBFBF',
       'color': '#000000'})   
       
merge_format_10 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#FFF2CC',
       'color': '#000000'})   

merge_format_11 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#FFE699',
       'color': '#000000'})   
       
merge_format_12 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#FFD966',
       'color': '#000000'})   

merge_format_13 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#DAE3F3',
       'color': '#000000'})  
       
merge_format_14 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#B4C7E7',
       'color': '#000000'})     
       
merge_format_15 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#8FAADC',
       'color': '#000000'})         
       
merge_format_16 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#E2F0D9',
       'color': '#000000'})           

merge_format_17 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#C5E0B4',
       'color': '#000000'})            
       
merge_format_18 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#A9D18E',
       'color': '#000000'})      
       
merge_format_19 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#FBE5D6',
       'color': '#000000'})        
       
merge_format_20 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'fg_color': '#F2F2F2',
       'color': '#000000'})  
       
merge_format_21 =workbook.add_format({
       'align' : 'center',
       'valign' : 'vcenter',
       'bold': True,
       'fg_color': '#70AD47',
       'color': '#ffffff'}) 
       
cf_1 = workbook.add_format({'bg_color': '#FBE5D6'
})

cf_2 = workbook.add_format({'bg_color': '#F2F2F2',
                           'text_wrap': True
})

cf_3 = workbook.add_format({'bg_color': '#D9D9D9',
                           'text_wrap': True
})

cf_4 = workbook.add_format({'bg_color': '#BFBFBF',
                           'text_wrap': True
})
cf_5 = workbook.add_format({'bg_color': '#FFF2CC',
                           'text_wrap': True
})
cf_6 = workbook.add_format({'bg_color': '#FFE699',
                           'text_wrap': True
})
cf_7 = workbook.add_format({'bg_color': '#FFD966',
                           'text_wrap': True
})

cf_8 = workbook.add_format({'bg_color': '#DAE3F3',
                           'text_wrap': True
})

cf_9 = workbook.add_format({'bg_color': '#B4C7E7',
                           'text_wrap': True
})
cf_10 = workbook.add_format({'bg_color': '#8FAADC',
                           'text_wrap': True
})
cf_11 = workbook.add_format({'bg_color': '#E2F0D9',
                           'text_wrap': True
})
cf_12 = workbook.add_format({'bg_color': '#C5E0B4',
                           'text_wrap': True
})
cf_13 = workbook.add_format({'bg_color': '#A9D18E',
                           'text_wrap': True
})

#Change this as well
worksheet.merge_range('C2:E2','Classification',merge_format_1)  
worksheet.merge_range('F2:N2', 'Proximate analysis',merge_format_2)
worksheet.merge_range('O2:AC2', 'Ultimate analysis',merge_format_3)
worksheet.merge_range('AD2:AL2', 'Halides',merge_format_4)
worksheet.merge_range('AM2:AR2', 'Heating value',merge_format_5)
worksheet.merge_range('AS2:BS2', 'Trace elements composition',merge_format_6)
worksheet.merge_range('BT2:CE2', 'Ash composition',merge_format_2)
worksheet.merge_range('CG2:CT2', 'Molecular composition',merge_format_3)
worksheet.merge_range('CU2:DQ2', 'Surrogate composition',merge_format_4)
worksheet.merge_range('DR2:DW2', 'Calculated',merge_format_21)

worksheet.set_row(3, 80)

worksheet.write(3, 2, 'Classification', workbook.add_format({'bold': True, 'size': 11,'fg_color': '#FBE5D6','color': '#000000' }))
list_letter = ['C','D','E']
b=2
for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       if i == 5:
           worksheet.write(cell,result.columns[b],cf_1)
           b+=1
       else:
           worksheet.write(cell,'',cf_1)
           
list_letter = ['F','G','H','I']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_2)
       if i == 4 :
           worksheet.write(cell,text,cf_2)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_2)
           b+=1
worksheet.merge_range('F3:I3', 'as received (ar)',merge_format_7)

list_letter = ['J','K','L']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_3)
       if i == 4 :
           worksheet.write(cell,text,cf_3)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_3)
           b+=1
worksheet.merge_range('J3:L3', 'dry including ash (dry)',merge_format_8)

list_letter = ['M','N']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_4)
       if i == 4 :
           worksheet.write(cell,text,cf_4)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_4)
           b+=1
worksheet.merge_range('M3:N3', 'dry ash free (daf)',merge_format_9)


list_letter = ['O','P','Q','R','S']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_5)
       if i == 4 :
           worksheet.write(cell,text,cf_5)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_5)
           b+=1
worksheet.merge_range('O3:S3', 'as received (ar)',merge_format_10)

list_letter = ['T','U','V','W','X']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_6)
       if i == 4 :
           worksheet.write(cell,text,cf_6)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_6)
           b+=1
worksheet.merge_range('T3:X3', 'dry including ash (dry)',merge_format_11)

list_letter = ['Y','Z','AA','AB','AC']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_7)
       if i == 4 :
           worksheet.write(cell,text,cf_7)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt%',cf_7)
           b+=1
worksheet.merge_range('Y3:AC3', 'dry ash free (daf)',merge_format_12)

list_letter = ['AD','AE','AF']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' mg/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_8)
       if i == 4 :
           worksheet.write(cell,text,cf_8)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'mg/kg',cf_8)
           b+=1
worksheet.merge_range('AD3:AF3', 'as received (ar)',merge_format_13)


list_letter = ['AG','AH','AI']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' mg/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_9)
       if i == 4 :
           worksheet.write(cell,text,cf_9)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'mg/kg',cf_9)
           b+=1
worksheet.merge_range('AG3:AI3', 'dry including ash (dry)',merge_format_14)

list_letter = ['AJ','AK','AL']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' mg/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_10)
       if i == 4 :
           worksheet.write(cell,text,cf_10)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'mg/kg',cf_10)
           b+=1
worksheet.merge_range('AJ3:AL3', 'dry ash free (daf)',merge_format_15)


list_letter = ['AM','AN']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' MJ/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_11)
       if i == 4 :
           worksheet.write(cell,text,cf_11)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'MJ/kg',cf_11)
           b+=1
worksheet.merge_range('AM3:AN3', 'as received (ar)',merge_format_16)


list_letter = ['AO','AP']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' MJ/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_12)
       if i == 4 :
           worksheet.write(cell,text,cf_12)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'MJ/kg',cf_12)
           b+=1
worksheet.merge_range('AO3:AP3', 'dry including ash (dry)',merge_format_17)

list_letter = ['AQ','AR']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' MJ/kg','')
       if i==3 :
           worksheet.write(cell,'',cf_13)
       if i == 4 :
           worksheet.write(cell,text,cf_13)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'MJ/kg',cf_13)
           b+=1
worksheet.merge_range('AQ3:AR3', 'dry ash free (daf)',merge_format_18)

list_letter =['AS','AT','AU','AV','AW','AX','AY','AZ','BA','BB','BC','BD','BE','BF','BG','BH','BI','BJ','BK','BL','BM','BN','BO','BP','BQ','BR','BS']
for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' mg/kg (dry)','')
       if i==3 :
           worksheet.write(cell,'',cf_1)
       if i == 4 :
           worksheet.write(cell,text,cf_1)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'mg/kg (dry)',cf_1)
           b+=1
worksheet.merge_range('AS3:BS3', '',merge_format_19)


list_letter =['BT','BU','BV','BW','BX','BY','BZ','CA','CB','CC','CD','CE']
for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt% (ash)','')
       if i==3 :
           worksheet.write(cell,'',cf_2)
       if i == 4 :
           worksheet.write(cell,text,cf_2)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell,'wt% (ash)',cf_2)
           b+=1
worksheet.merge_range('BT3:CE3', '',merge_format_20)
b+=1

list_letter = ['CG','CH']

# for i in range(3,6):
#    for letter in list_letter:
#        cell = str(letter)+str(i)
#        text = result.columns[b]
#        text=text.replace(' Mj/kg','')
#        if i==3 :
#            worksheet.write(cell,'',cf_11)
#        if i == 4 :
#            worksheet.write(cell,text,cf_11)
#            b+=1
#        if i == 5 :
#            b-=1
#            worksheet.write(cell,'Mj/kg',cf_11)
#            b+=1
# worksheet.merge_range('CG3:CH3', '',merge_format_16)

list_letter = ['CG','CH','CI','CJ','CK','CL','CM','CN']

#Remove and change code
for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_5)
       if i == 4 :
           worksheet.write(cell,text,cf_5)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell, 'wt%',cf_5)
           b+=1
worksheet.merge_range('CG3:CN3', 'as received (ar)',merge_format_10)

list_letter = ['CO','CP','CQ','CR','CS','CT']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_7)
       if i == 4 :
           worksheet.write(cell,text,cf_7)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell, 'wt%',cf_7)
           b+=1
worksheet.merge_range('CO3:CT3', 'dry ash free (daf)',merge_format_12)

list_letter = ['CU','CV','CW','CX','CY','CZ','DA','DB','DC','DD','DE','DF','DG','DH','DI','DJ','DK','DL','DM','DN', 'DO', 'DP', 'DQ']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       text = result.columns[b]
       text=text.replace(' wt%','')
       if i==3 :
           worksheet.write(cell,'',cf_8)
       if i == 4 :
           worksheet.write(cell,text,cf_8)
           b+=1
       if i == 5 :
           b-=1
           worksheet.write(cell, 'wt%',cf_8)
           b+=1
worksheet.merge_range('CU3:DQ3', '',merge_format_13)

list_letter = ['DR','DS','DT','DU','DV','DW']

for i in range(3,6):
   for letter in list_letter:
       cell = str(letter)+str(i)
       if i == 5:
           worksheet.write(cell,result.columns[b],cf_11)
           b+=1
       else:
           worksheet.write(cell,'',cf_11)
           
           
worksheet.merge_range('DR3:DW3', '',merge_format_16)

writer.save()


valuesCS = []
valuesHS = []
valuesOS = []
valuesNS = []
valuesSS = []
valuesClS = []
valuesCELL = []
valuesHCE = []
valuesLIG = []
valuesPROT = []
valuesNH3 = []
valuesCO2 = []
valuesSulphur = []
valuesSugar = []
valuesLipid = []
valuesPE = []
valuesPS = []
valuesPP = []
valuesPA = []
valuesPVC = []
valuesPET = []
valuesNR = []
valuesASPH = []

for i in range(0, len(table2)):
    valuesCS.append(table2.iloc[i,8])

for i in range(0, len(table2)):
    valuesHS.append(table2.iloc[i,9])

for i in range(0, len(table2)):
    valuesOS.append(table2.iloc[i,10])

for i in range(0, len(table2)):
    valuesNS.append(table2.iloc[i,11])

for i in range(0, len(table2)):
    valuesSS.append(table2.iloc[i,13])

for i in range(0, len(table2)):
    valuesClS.append(table2.iloc[i,12])

for i in range(0, len(table2)):
    valuesCELL.append(table2.iloc[i,14]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesHCE.append(table2.iloc[i,15]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesLIG.append((table2.iloc[i,16] + table2.iloc[i,17] + table2.iloc[i,18])/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesPROT.append((table2.iloc[i,19] + table2.iloc[i,20] + table2.iloc[i,21])/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesNH3.append(table2.iloc[i,24]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesCO2.append(table2.iloc[i,25]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesSulphur.append(table2.iloc[i,26]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesSugar.append(table2.iloc[i,22]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesLipid.append(table2.iloc[i,23]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesPE.append(table2.iloc[i,27]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesPS.append(table2.iloc[i,28]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))
    
for i in range(0, len(table2)):
    valuesPVC.append(table2.iloc[i,29]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesPA.append(table2.iloc[i,30]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))
    
for i in range(0, len(table2)):
    valuesPP.append(table2.iloc[i,31]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesPET.append(table2.iloc[i,32]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesNR.append(table2.iloc[i,33]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))

for i in range(0, len(table2)):
    valuesASPH.append(table2.iloc[i,34]/(1-(table2.iloc[i,35]/100)-(table2.iloc[i,36]/100)))
    

valuesC = []
valuesH = []
valuesO = []
valuesN = []
valuesS = []
valuesCl = []
fossilC = []

for i in range(0, len(table2)):
    valuesC.append(table.iloc[i,24])
    valuesC[i] = float(valuesC[i])

for i in range(0, len(table2)):
    valuesH.append(table.iloc[i,25])
    valuesH[i] = float(valuesH[i])

for i in range(0, len(table2)):
    valuesO.append(table.iloc[i,26])
    valuesO[i] = float(valuesO[i])

for i in range(0, len(table2)):
    valuesN.append(table.iloc[i,27])

for i in range(0, len(table2)):
    valuesS.append(table.iloc[i,28])

for i in range(0, len(table2)):
    valuesCl.append(table.iloc[i,36]/10000)

for i in range(0, len(table2)):
    fossilC.append(table2.iloc[i,43])


valuesHHVARS = []
valuesHHVDAFS = []
valuesHHVAR = []
valuesHHVDAF = []


for i in range(0, len(table)):
    valuesHHVAR.append(table.iloc[i,39])

for i in range(0, len(table)):
    valuesHHVDAF.append(table.iloc[i,43])

for i in range(0, len(table2)):
    valuesHHVDAFS.append(table2.iloc[i,41])

for i in range(0, len(table2)):
    valuesHHVARS.append(table2.iloc[i,42])

for i in range(0,len(valuesHHVAR)):
    if valuesHHVAR[i] == ' ':
        valuesHHVAR[i] = '0'
        valuesHHVARS[i] = '0'

for i in range(0,len(valuesHHVARS)):
    if valuesHHVAR[i] == ' ':
        valuesHHVARS[i] = '0'
        valuesHHVAR[i] = '0'

for i in range(0,len(valuesHHVDAF)):
    if valuesHHVDAF[i] == ' ':
        valuesHHVDAF[i] = '0'

for i in range(0,len(valuesHHVDAFS)):
    if valuesHHVDAFS[i] == ' ':
        valuesHHVDAFS[i] = '0'

for i in range(0,len(valuesHHVAR)):
        valuesHHVAR[i] = float(valuesHHVAR[i])

for i in range(0,len(valuesHHVARS)):
        valuesHHVARS[i] = float(valuesHHVARS[i])

for i in range(0,len(valuesHHVDAF)):
        valuesHHVDAF[i] = float(valuesHHVDAF[i])

for i in range(0,len(valuesHHVDAFS)):
        valuesHHVDAFS[i] = float(valuesHHVDAFS[i])

cellAvg = statistics.mean(valuesCELL)
hceAvg = statistics.mean(valuesHCE)
ligAvg = statistics.mean(valuesLIG)
protAvg = statistics.mean(valuesPROT)
lipidAvg = statistics.mean(valuesLipid)
sugarAvg = statistics.mean(valuesSugar)
NH3Avg = statistics.mean(valuesNH3)
CO2Avg = statistics.mean(valuesCO2)
SulphurAvg = statistics.mean(valuesSulphur)
PEAvg = statistics.mean(valuesPE)
PPAvg = statistics.mean(valuesPP)
PVCAvg = statistics.mean(valuesPVC)
PAAvg = statistics.mean(valuesPA)
PSAvg = statistics.mean(valuesPS)
PETAvg = statistics.mean(valuesPET)
NRAvg = statistics.mean(valuesNR)
ASPHAvg = statistics.mean(valuesASPH)
cSurrAvg = statistics.mean(valuesCS)
hSurrAvg = statistics.mean(valuesHS)
oSurrAvg = statistics.mean(valuesOS)
nSurrAvg = statistics.mean(valuesNS)
sSurrAvg = statistics.mean(valuesSS)
clSurrAvg = statistics.mean(valuesClS)
cExpAvg = statistics.mean(valuesC)
hExpAvg = statistics.mean(valuesH)
oExpAvg = statistics.mean(valuesO)
nExpAvg = statistics.mean(valuesN)
sExpAvg = statistics.mean(valuesS)
clExpAvg = statistics.mean(valuesCl)
hhvExpAvg = statistics.mean(valuesHHVDAF)
hhvSurrAvg = statistics.mean(valuesHHVDAFS)
fossilCAvg = statistics.mean(fossilC)


print('C Experimental = ', cExpAvg)
print('H Experimental = ',  hExpAvg)
print('O Experimental = ', oExpAvg)
print('N Experimental = ', nExpAvg)
print('S Experimental = ', sExpAvg)
print('Cl Experimental = ', clExpAvg)
print('HHV Experimental = ', hhvExpAvg)
print('Extractives = ', 100 - cellAvg - hceAvg - ligAvg)
print('C Surrogate = ', cSurrAvg)
print('H Surrogate = ',  hSurrAvg)
print('O Surrogate = ', oSurrAvg)
print('N Surrogate = ', nSurrAvg)
print('S Surrogate = ', sSurrAvg)
print('Cl Surrogate = ', clSurrAvg)
print('HHV Surrogate = ', hhvSurrAvg)

print('Cell = ', cellAvg)
print('Hce = ',  hceAvg)
print('Lignin = ', ligAvg)
print('Protein = ', protAvg)
print('Lipid = ', lipidAvg)
print('Sugar = ', sugarAvg)
print('CO2 = ',  CO2Avg)
print('NH3 = ', NH3Avg)
print('Sulphur = ',  SulphurAvg)
print('PE = ',  PEAvg)
print('PS = ',  PSAvg)
print('PP = ',  PPAvg)
print('PA = ',  PAAvg)
print('PVC = ',  PVCAvg)
print('PET = ',  PETAvg)
print('NR = ',  NRAvg)
print('ASPH = ',  ASPHAvg)

print('Fossil C = ', fossilCAvg)

# x4 = valuesHHVDAF
# y4 = valuesHHVDAFS
# fig = plt.figure(4)
# ax1 = fig.add_subplot(111)
# ax1.scatter(x4,y4, marker ='x', color = 'red')
# ax1.plot([0, 1], [0, 1], transform=ax1.transAxes, color= 'black')
# plt.xlabel('HHV, dry ash free, experimental [MJ/kg]')
# plt.ylabel('HHV, dry ash free, surrogate [MJ/kg]')
# plt.title("Scatter plot of HHV from surrogate model \n compared to experimental values")
# plt.xlim([30,45])
# plt.ylim([30,45])
# plt.show()

# z = valuesC
# h = valuesCS
# fig = plt.figure()
# ax1 = fig.add_subplot(111)
# ax1.scatter(z,h, marker ='x', label = 'Carbon')
# ax1.plot([0, 1], [0, 1], transform=ax1.transAxes, color= 'black')
# plt.legend(loc='upper left')
# plt.title("Scatter plot of C levels from surrogate \n model compared to experimental values")
# plt.ylabel('Surrogates [wt%]')
# plt.xlabel('Experimental [wt%]')
# plt.xlim([80,100])
# plt.ylim([80,100])
# plt.show()

# z2 = valuesH
# h2 = valuesHS
# z3 = valuesO
# h3 = valuesOS
# fig = plt.figure()
# ax1 = fig.add_subplot(111)
# ax1.scatter(z2,h2, marker = 'o', label = 'Hydrogen')
# ax1.scatter(z3,h3, marker = 'o', label = 'Oxygen')
# ax1.plot([0, 1], [0, 1], transform=ax1.transAxes, color= 'black')
# # ax1.plot([0.05, 1], [0, 0.95], transform=ax1.transAxes, color= 'black')
# # ax1.plot([0, 0.95], [0.05, 1], transform=ax1.transAxes, color= 'black')
# plt.title("Scatter plot of H and O levels from surrogate \n model compared to experimental value")
# plt.legend(loc='upper left')
# plt.ylabel('Surrogates [wt%]')
# plt.xlabel('Experimental [wt%]')
# plt.xlim([0,10])
# plt.ylim([0,10])
# plt.show()

# z4 = valuesN
# h4 = valuesNS
# z5 = valuesS
# h5 = valuesSS
# z6 = valuesCl
# h6 = valuesClS
# fig = plt.figure()
# ax1 = fig.add_subplot(111)
# ax1.scatter(z4,h4, marker = 'x', label = 'Nitrogen')
# ax1.scatter(z5,h5, marker = 'o', label = 'Sulphur')
# ax1.scatter(z6,h6, marker = 'v', label = 'Chlorine')
# ax1.plot([0, 1], [0, 1], transform=ax1.transAxes, color= 'black') 
# # ax1.plot([0.05, 1], [0, 0.95], transform=ax1.transAxes, color= 'black')
# # ax1.plot([0, 0.95], [0.05, 1], transform=ax1.transAxes, color= 'black')
# plt.title("Scatter plot of N and S levels from surrogate \n model compared to experimental value")
# plt.legend(loc='upper left')
# plt.ylabel('Surrogates [wt%]')
# plt.xlabel('Experimental [wt%]')
# plt.xlim([0,1])
# plt.ylim([0,1])
# plt.show()


# z5 = valuesCl
# h5 = valuesClS
# fig = plt.figure()
# ax1 = fig.add_subplot(111)
# ax1.scatter(z5,h5, marker = 'v', label = 'Chlorine')
# ax1.plot([0, 1], [0, 1], transform=ax1.transAxes, color= 'black') 
# # ax1.plot([0.05, 1], [0, 0.95], transform=ax1.transAxes, color= 'black')
# # ax1.plot([0, 0.95], [0.05, 1], transform=ax1.transAxes, color= 'black')
# plt.title("Scatter plot of Cl levels from surrogate \n model compared to experimental value")
# plt.legend(loc='upper left')
# plt.ylabel('Surrogates [wt%]')
# plt.xlabel('Experimental [wt%]')
# # plt.xlim([45,60])
# # plt.ylim([45,60])
# plt.show()


# fig = plt.figure()
# ax = fig.add_subplot(111)
# columns = [valuesCELL, valuesHCE, valuesLIG, valuesSugar, valuesLipid, valuesPROT]
# bp = ax.boxplot(columns, meanline=True, showmeans=True)
# plt.xticks([1,2,3,4,5,6], ["Cellulose", "PE", "Sulphur", "CO2", "NH3", "PS"], rotation=0)
# # plt.title("Box plot of NH3, sulphur and CO2 surrogates")
# plt.ylabel('Amount [wt%]')
# plt.show()

# fig = plt.figure()
# ax = fig.add_subplot(111)
# columns = [valuesNR,valuesPS, valuesPET]
# bp = ax.boxplot(columns, meanline=True, showmeans=True)
# plt.xticks([1,2,3], ["Natural Rubber", "PS","PET"], rotation=0)
# # plt.title("Box plot of NH3, sulphur and CO2 surrogates")
# plt.ylabel('Amount [wt%]')
# plt.show()

relErrC = abs(1-(round(cSurrAvg,3)/round(cExpAvg,3)))*100
relErrH = abs(1-(round(hSurrAvg,3)/round(hExpAvg,3)))*100
relErrO  = abs(1-(round(oSurrAvg,3)/round(oExpAvg,3)))*100
relErrN = abs(1-(round(nSurrAvg,3)/round(nExpAvg,3)))*100
relErrS = abs(1-(round(sSurrAvg,3)/round(sExpAvg,3)))*100
relErrCl = abs(1-(round(clSurrAvg,3)/round(clExpAvg,3)))*100
relErrHHV = abs(1-(round(hhvSurrAvg,3)/round(hhvExpAvg,3)))*100

print('Relative error C: ', relErrC)
print('Relative error H: ', relErrH)
print('Relative error O: ', relErrO)
print('Relative error N: ', relErrN)
print('Relative error S: ', relErrS)
print('Relative error Cl: ', relErrCl)
print('Relative error HHV: ', relErrHHV)


valuesN2 = []
for i in range (0,len(valuesN)):
    if valuesN[i] > 0:
        y = valuesN[i]
        valuesN2.append(y)

valuesNS2 = []
for i in range (0,len(valuesNS)):
    if valuesNS[i] > 0:
        y = valuesNS[i]
        valuesNS2.append(y)

valuesS2 = []
for i in range (0,len(valuesS)):
    if valuesS[i] > 0:
        y = valuesS[i]
        valuesS2.append(y)

valuesSS2 = []
for i in range (0,len(valuesSS)):
    if valuesSS[i] > 0:
        y = valuesSS[i]
        valuesSS2.append(y)

valuesCl2 = []
for i in range (0,len(valuesCl)):
    if valuesCl[i] > 0:
        y = valuesCl[i]
        valuesCl2.append(y)

valuesClS2 = []
for i in range (0,len(valuesClS)):
    if valuesClS[i] > 0:
        y = valuesClS[i]
        valuesClS2.append(y)


valuesExp = [valuesN2]
valuesSurr = [valuesNS2]
ticks = ['Nitrogen','HHV']
fig, ax1 = plt.subplots()
exp_plot = ax1.boxplot(valuesExp,
                               positions=np.array(
    np.arange(len(valuesExp)))*2.0-0.35,
                               widths=0.6,meanline=True, showmeans=True)
surr_plot = ax1.boxplot(valuesSurr,
                               positions=np.array(
    np.arange(len(valuesSurr)))*2.0+0.35,
                               widths=0.6,meanline=True, showmeans=True)
def define_box_properties(plot_name, color_code, label):
    for k, v in plot_name.items():
        plt.setp(plot_name.get(k), color=color_code)
         
    plt.plot([], c=color_code, label=label)
    plt.legend()
 
define_box_properties(exp_plot, '#D7191C', 'Experiments')
define_box_properties(surr_plot, '#2C7BB6', 'Surrogate Model')
 
ax2 = ax1.twinx()

valuesExp2 = [valuesHHVDAF]
valuesSurr2 = [valuesHHVDAFS]
exp2_plot = ax2.boxplot(valuesExp2,
                               positions=np.array(
    np.arange(len(valuesExp2)))*2.0-0.35+2,
                               widths=0.6,meanline=True, showmeans=True)
surr2_plot = ax2.boxplot(valuesSurr2,
                               positions=np.array(
    np.arange(len(valuesSurr2)))*2.0+0.35+2,
                               widths=0.6,meanline=True, showmeans=True)
def define_box_properties(plot_name, color_code, label):
    for k, v in plot_name.items():
        plt.setp(plot_name.get(k), color=color_code)
         
    plt.plot([], c=color_code, label=label)
    # plt.legend()
 
define_box_properties(exp2_plot, '#D7191C', 'Experiments')
define_box_properties(surr2_plot, '#2C7BB6', 'Surrogate Model')
 
plt.xticks(np.arange(0, len(ticks) * 2, 2), ticks)
plt.xlim(-2, len(ticks)*2)
# ax1.set_ylim(0, 1.5)
ax2.set_ylim(16,26)
ax2.set_ylabel('MJ/kg')
ax1.set_ylabel('wt%')
# plt.title("Waste class 6004 (MSW) \n Dry-ash free basis \n N outlier at wt%=12 not included in plot")
plt.show()

valuesExp3 = [valuesS2, valuesCl2]
valuesSurr3 = [valuesSS2, valuesClS2]
ticks2 = ['Sulphur', 'Chlorine']
exp_plot3 = plt.boxplot(valuesExp3,
                               positions=np.array(
    np.arange(len(valuesExp3)))*2.0-0.35,
                               widths=0.6,meanline=True, showmeans=True)
surr_plot3 = plt.boxplot(valuesSurr3,
                               positions=np.array(
    np.arange(len(valuesSurr3)))*2.0+0.35,
                               widths=0.6,meanline=True, showmeans=True)
def define_box_properties(plot_name, color_code, label):
    for k, v in plot_name.items():
        plt.setp(plot_name.get(k), color=color_code)
         
    plt.plot([], c=color_code, label=label)
    plt.legend()
 
define_box_properties(exp_plot3, '#D7191C', 'Experiments')
define_box_properties(surr_plot3, '#2C7BB6', 'Surrogate Model')
plt.xticks(np.arange(0, len(ticks2) * 2, 2), ticks2)
plt.xlim(-2, len(ticks2)*2)
# plt.ylim(1,3)
plt.ylabel('wt%')
# plt.title("Waste class 9911 (MSW) \n Dry-ash free basis")
plt.show()

fig2 = plt.figure()
N = 1
ind = np.arange(N) # the x locations for the groups
ax2 = fig2.add_subplot(111)
width = 0.35
fig2 = plt.figure()
# ax2 = fig2.add_axes([0,0,1,1])
ax2.bar(ind, cellAvg, width, color='r')
ax2.bar(ind, hceAvg, width,bottom=cellAvg, color='b')
ax2.bar(ind, ligAvg, width,bottom=hceAvg+cellAvg, color='y')
ax2.bar(ind, protAvg, width,bottom=ligAvg+cellAvg+hceAvg, color='g')
ax2.bar(ind, CO2Avg, width,bottom=ligAvg+cellAvg+hceAvg+protAvg, color='black')
ax2.bar(ind, NH3Avg, width,bottom=ligAvg+cellAvg+hceAvg+protAvg+CO2Avg, color='orange')
ax2.bar(ind, SulphurAvg, width,bottom=ligAvg+cellAvg+hceAvg+protAvg+CO2Avg+NH3Avg, color='purple')

# ax2.set_ylabel('wt%')
# # ax.set_title('Scores by group and gender')
# ax2.legend(labels=['Cellulose', 'hemicellulose', 'Lignin', 'Protein', 'CO2', 'NH3', 'Sulphur'])
# plt.show()

MinimumNExp = min(valuesN2)
MinimumNSurr = min(valuesNS2)
MinimumHHVExp = min(valuesHHVDAF)
MinimumHHVSurr = min(valuesHHVDAFS)
MinimumSExp = min(valuesS2)
MinimumSSurr = min(valuesSS2)
MinimumClExp = min(valuesCl2)
# MinimumClSurr = min(valuesClS2)
MaxNExp = max(valuesN2)
MaxNSurr = max(valuesNS2)
MaxHHVExp = max(valuesHHVDAF)
MaxHHVSurr = max(valuesHHVDAFS)
MaxSExp = max(valuesS2)
MaxSSurr = max(valuesSS2)
MaxClExp = max(valuesCl2)
# MaxClSurr = max(valuesClS2)
AvgNExp = statistics.mean(valuesN2)
AvgNSurr = statistics.mean(valuesNS2)
AvgHHVExp = statistics.mean(valuesHHVDAF)
AvgHHVSurr = statistics.mean(valuesHHVDAFS)
AvgSExp = statistics.mean(valuesS2)
AvgSSurr = statistics.mean(valuesSS2)
AvgClExp = statistics.mean(valuesCl2)
# AvgClSurr = statistics.mean(valuesClS2)

print('Min N-Exp: ', MinimumNExp)
print('Min N-Surr: ', MinimumNSurr)
print('Min HHV-Exp: ', MinimumHHVExp)
print('Min HHV-Surr: ', MinimumHHVSurr)
print('Min S-Exp: ', MinimumSExp)
print('Min S-Surr: ', MinimumSSurr)
print('Min Cl-Exp: ', MinimumClExp)
# print('Min Cl-Surr: ', MinimumClSurr)
print('Max N-Exp: ', MaxNExp)
print('Max N-Surr: ', MaxNSurr)
print('Max HHV-Exp: ', MaxHHVExp)
print('Max HHV-Surr: ', MaxHHVSurr)
print('Max S-Exp: ', MaxSExp)
print('Max S-Surr: ', MaxSSurr)
print('Max Cl-Exp: ', MaxClExp)
# print('Max Cl-Surr: ', MaxClSurr)
# print('Max Cl-Surr: ', MaxClSurr)
print('Avg N-Exp: ', AvgNExp)
print('Avg N-Surr: ', AvgNSurr)
print('Avg HHV-Exp: ', AvgHHVExp)
print('Avg HHV-Surr: ', AvgHHVSurr)
print('Avg S-Exp: ', AvgSExp)
print('Avg S-Surr: ', AvgSSurr)
print('Avg Cl-Exp: ', AvgClExp)
# print('Avg Cl-Surr: ', AvgClSurr)